"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const core_1 = require("@collectable/core");
class Node {
    constructor(mctx, key, value, _red, _left, _right, _count) {
        this.key = key;
        this.value = value;
        this._red = _red;
        this._left = _left;
        this._right = _right;
        this._count = _count;
        this['@@mctx'] = mctx;
    }
    /** @internal */
    '@@clone'(mctx) {
        return new Node(mctx, this.key, this.value, this._red, this._left, this._right, this._count);
    }
}
exports.Node = Node;
const anyVoid = void 0;
exports.NONE = new Node(core_1.Mutation.immutable(), anyVoid, anyVoid, false, anyVoid, anyVoid, 0);
exports.NONE._left = exports.NONE;
exports.NONE._right = exports.NONE;
function createNode(tree, red, key, value) {
    return new Node(core_1.Mutation.getSubordinateContext(tree), key, value, red, exports.NONE, exports.NONE, 1);
}
exports.createNode = createNode;
function isNone(node) {
    return node === exports.NONE;
}
exports.isNone = isNone;
function editRightChild(owner, node) {
    var child = node._right;
    return isNone(child) || core_1.Mutation.areContextsRelated(child, owner) ? child
        : (node._right = (child = core_1.Mutation.modifyAsSubordinate(owner, child)), child);
}
exports.editRightChild = editRightChild;
function editLeftChild(owner, node) {
    var child = node._left;
    return isNone(child) || core_1.Mutation.areContextsRelated(child, owner) ? child
        : (node._left = (child = core_1.Mutation.modifyAsSubordinate(owner, child)), child);
}
exports.editLeftChild = editLeftChild;
function assignValue(value, node) {
    const v = node.value;
    // Note the double-equals below is used to correctly compare Symbol() with Object(Symbol())
    if (v === value || (v !== null && typeof v === 'object' && v == value)) {
        return false;
    }
    node.value = value;
    return true;
}
exports.assignValue = assignValue;

//# sourceMappingURL=node.js.map
